require 'enrich/auto_delegate'

module Enrich
  class Base
    include AutoDelegate

    class << self
      def decorate(object)
        if object.is_a?(ActiveRecord::Base)
          new(object)
        else
          object.map { |obj| new(obj) }
        end
      end

      alias_method :d, :decorate
    end

    def initialize(object)
      @object = object
    end

    def object
      @object
    end

    # Ability to use ActionController helpers
    def h
      ActionController::Base.helpers
    end
  end
end
